## victoriametrics 1.112.0+ds1

=== Makefile ===
PKG_PREFIX := github.com/VictoriaMetrics/VictoriaMetrics

MAKE_CONCURRENCY ?= $(shell getconf _NPROCESSORS_ONLN)
MAKE_PARALLEL := $(MAKE) -j $(MAKE_CONCURRENCY)
DATEINFO_TAG ?= $(shell date -u +'%Y%m%d-%H%M%S')
BUILDINFO_TAG ?= $(shell echo $$(git describe --long --all | tr '/' '-')$$( \
	      git diff-index --quiet HEAD -- || echo '-dirty-'$$(git diff-index -u HEAD | openssl sha1 | cut -d' ' -f2 | cut -c 1-8)))
LATEST_TAG ?= latest

PKG_TAG ?= $(shell git tag -l --points-at HEAD)
ifeq ($(PKG_TAG),)
PKG_TAG := $(BUILDINFO_TAG)
endif

GO_BUILDINFO = -X '$(PKG_PREFIX)/lib/buildinfo.Version=$(APP_NAME)-$(DATEINFO_TAG)-$(BUILDINFO_TAG)'
TAR_OWNERSHIP ?= --owner=1000 --group=1000

.PHONY: $(MAKECMDGOALS)

include app/*/Makefile
include cspell/Makefile
include docs/Makefile
include deployment/*/Makefile
include dashboards/Makefile
include package/release/Makefile

all: \
	victoria-metrics-prod \
	victoria-logs-prod \
	vlogscli-prod \
	vmagent-prod \
	vmalert-prod \
	vmalert-tool-prod \
	vmauth-prod \
	vmbackup-prod \
	vmrestore-prod \
	vmctl-prod

clean:
	rm -rf bin/*

publish: \
	publish-victoria-metrics \
	publish-vmagent \
	publish-vmalert \
	publish-vmalert-tool \
	publish-vmauth \
	publish-vmbackup \
	publish-vmrestore \
	publish-vmctl

package: \
	package-victoria-metrics \
	package-victoria-logs \
	package-vlogscli \
	package-vmagent \
	package-vmalert \
	package-vmalert-tool \
	package-vmauth \
	package-vmbackup \
	package-vmrestore \
	package-vmctl

vmutils: \
	vmagent \
	vmalert \
	vmalert-tool \
	vmauth \
	vmbackup \
	vmrestore \
	vmctl

vmutils-pure: \
	vmagent-pure \
	vmalert-pure \
	vmalert-tool-pure \
	vmauth-pure \
	vmbackup-pure \
	vmrestore-pure \
	vmctl-pure

vmutils-linux-amd64: \
	vmagent-linux-amd64 \
	vmalert-linux-amd64 \
	vmalert-tool-linux-amd64 \
	vmauth-linux-amd64 \
	vmbackup-linux-amd64 \
	vmrestore-linux-amd64 \
	vmctl-linux-amd64

vmutils-linux-arm64: \
	vmagent-linux-arm64 \
	vmalert-linux-arm64 \
	vmalert-tool-linux-arm64 \
	vmauth-linux-arm64 \
	vmbackup-linux-arm64 \
	vmrestore-linux-arm64 \
	vmctl-linux-arm64

vmutils-linux-arm: \
	vmagent-linux-arm \
	vmalert-linux-arm \
	vmalert-tool-linux-arm \
	vmauth-linux-arm \
	vmbackup-linux-arm \
	vmrestore-linux-arm \
	vmctl-linux-arm

vmutils-linux-386: \
	vmagent-linux-386 \
	vmalert-linux-386 \
	vmalert-tool-linux-386 \
	vmauth-linux-386 \
	vmbackup-linux-386 \
	vmrestore-linux-386 \
	vmctl-linux-386

vmutils-linux-ppc64le: \
	vmagent-linux-ppc64le \
	vmalert-linux-ppc64le \
	vmalert-tool-linux-ppc64le \
	vmauth-linux-ppc64le \
	vmbackup-linux-ppc64le \
	vmrestore-linux-ppc64le \
	vmctl-linux-ppc64le

vmutils-darwin-amd64: \
	vmagent-darwin-amd64 \
	vmalert-darwin-amd64 \
	vmalert-tool-darwin-amd64 \
	vmauth-darwin-amd64 \
	vmbackup-darwin-amd64 \
	vmrestore-darwin-amd64 \
	vmctl-darwin-amd64

vmutils-darwin-arm64: \
	vmagent-darwin-arm64 \
	vmalert-darwin-arm64 \
	vmalert-tool-darwin-arm64 \
	vmauth-darwin-arm64 \
	vmbackup-darwin-arm64 \
	vmrestore-darwin-arm64 \
	vmctl-darwin-arm64

vmutils-freebsd-amd64: \
	vmagent-freebsd-amd64 \
	vmalert-freebsd-amd64 \
	vmalert-tool-freebsd-amd64 \
	vmauth-freebsd-amd64 \
	vmbackup-freebsd-amd64 \
	vmrestore-freebsd-amd64 \
	vmctl-freebsd-amd64

vmutils-openbsd-amd64: \
	vmagent-openbsd-amd64 \
	vmalert-openbsd-amd64 \
	vmalert-tool-openbsd-amd64 \
	vmauth-openbsd-amd64 \
	vmbackup-openbsd-amd64 \
	vmrestore-openbsd-amd64 \
	vmctl-openbsd-amd64

vmutils-windows-amd64: \
	vmagent-windows-amd64 \
	vmalert-windows-amd64 \
	vmalert-tool-windows-amd64 \
	vmauth-windows-amd64 \
	vmbackup-windows-amd64 \
	vmrestore-windows-amd64 \
	vmctl-windows-amd64

crossbuild:
	$(MAKE_PARALLEL) victoria-metrics-crossbuild vmutils-crossbuild

victoria-metrics-crossbuild: \
	victoria-metrics-linux-386 \
	victoria-metrics-linux-amd64 \
	victoria-metrics-linux-arm64 \
	victoria-metrics-linux-arm \
	victoria-metrics-linux-ppc64le \
	victoria-metrics-darwin-amd64 \
	victoria-metrics-darwin-arm64 \
	victoria-metrics-freebsd-amd64 \
	victoria-metrics-openbsd-amd64 \
	victoria-metrics-windows-amd64

vmutils-crossbuild: \
	vmutils-linux-386 \
	vmutils-linux-amd64 \
	vmutils-linux-arm64 \
	vmutils-linux-arm \
	vmutils-linux-ppc64le \
	vmutils-darwin-amd64 \
	vmutils-darwin-arm64 \
	vmutils-freebsd-amd64 \
	vmutils-openbsd-amd64 \
	vmutils-windows-amd64

publish-release:
	rm -rf bin/*
	git checkout $(TAG) && $(MAKE) release && LATEST_TAG=stable $(MAKE) publish && \
		git checkout $(TAG)-cluster && $(MAKE) release && LATEST_TAG=cluster-stable $(MAKE) publish && \
		git checkout $(TAG)-enterprise && $(MAKE) release && LATEST_TAG=enterprise-stable $(MAKE) publish && \
		git checkout $(TAG)-enterprise-cluster && $(MAKE) release && LATEST_TAG=enterprise-cluster-stable $(MAKE) publish

release:
	$(MAKE_PARALLEL) \
		release-victoria-metrics \
		release-vmutils

release-victoria-metrics: \
	release-victoria-metrics-linux-386 \
	release-victoria-metrics-linux-amd64 \
	release-victoria-metrics-linux-arm \
	release-victoria-metrics-linux-arm64 \
	release-victoria-metrics-darwin-amd64 \
	release-victoria-metrics-darwin-arm64 \
	release-victoria-metrics-freebsd-amd64 \
	release-victoria-metrics-openbsd-amd64 \
	release-victoria-metrics-windows-amd64

release-victoria-metrics-linux-386:
	GOOS=linux GOARCH=386 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-linux-amd64:
	GOOS=linux GOARCH=amd64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-linux-arm:
	GOOS=linux GOARCH=arm $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-linux-arm64:
	GOOS=linux GOARCH=arm64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-darwin-amd64:
	GOOS=darwin GOARCH=amd64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-darwin-arm64:
	GOOS=darwin GOARCH=arm64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-freebsd-amd64:
	GOOS=freebsd GOARCH=amd64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-openbsd-amd64:
	GOOS=openbsd GOARCH=amd64 $(MAKE) release-victoria-metrics-goos-goarch

release-victoria-metrics-windows-amd64:
	GOARCH=amd64 $(MAKE) release-victoria-metrics-windows-goarch

release-victoria-metrics-goos-goarch: victoria-metrics-$(GOOS)-$(GOARCH)-prod
	cd bin && \
		tar $(TAR_OWNERSHIP) --transform="flags=r;s|-$(GOOS)-$(GOARCH)||" -czf victoria-metrics-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(GOOS)-$(GOARCH)-prod \
		&& sha256sum victoria-metrics-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(GOOS)-$(GOARCH)-prod \
			| sed s/-$(GOOS)-$(GOARCH)-prod/-prod/ > victoria-metrics-$(GOOS)-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf victoria-metrics-$(GOOS)-$(GOARCH)-prod

release-victoria-metrics-windows-goarch: victoria-metrics-windows-$(GOARCH)-prod
	cd bin && \
		zip victoria-metrics-windows-$(GOARCH)-$(PKG_TAG).zip \
			victoria-metrics-windows-$(GOARCH)-prod.exe \
		&& sha256sum victoria-metrics-windows-$(GOARCH)-$(PKG_TAG).zip \
			victoria-metrics-windows-$(GOARCH)-prod.exe \
			> victoria-metrics-windows-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf \
		victoria-metrics-windows-$(GOARCH)-prod.exe

release-victoria-logs-bundle: \
	release-victoria-logs \
	release-vlogscli

publish-victoria-logs-bundle: \
	publish-victoria-logs \
	publish-vlogscli

release-victoria-logs:
	$(MAKE_PARALLEL) release-victoria-logs-linux-386 \
		release-victoria-logs-linux-amd64 \
		release-victoria-logs-linux-arm \
		release-victoria-logs-linux-arm64 \
		release-victoria-logs-darwin-amd64 \
		release-victoria-logs-darwin-arm64 \
		release-victoria-logs-freebsd-amd64 \
		release-victoria-logs-openbsd-amd64 \
		release-victoria-logs-windows-amd64

release-victoria-logs-linux-386:
	GOOS=linux GOARCH=386 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-linux-amd64:
	GOOS=linux GOARCH=amd64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-linux-arm:
	GOOS=linux GOARCH=arm $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-linux-arm64:
	GOOS=linux GOARCH=arm64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-darwin-amd64:
	GOOS=darwin GOARCH=amd64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-darwin-arm64:
	GOOS=darwin GOARCH=arm64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-freebsd-amd64:
	GOOS=freebsd GOARCH=amd64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-openbsd-amd64:
	GOOS=openbsd GOARCH=amd64 $(MAKE) release-victoria-logs-goos-goarch

release-victoria-logs-windows-amd64:
	GOARCH=amd64 $(MAKE) release-victoria-logs-windows-goarch

release-victoria-logs-goos-goarch: victoria-logs-$(GOOS)-$(GOARCH)-prod
	cd bin && \
		tar $(TAR_OWNERSHIP) --transform="flags=r;s|-$(GOOS)-$(GOARCH)||" -czf victoria-logs-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-logs-$(GOOS)-$(GOARCH)-prod \
		&& sha256sum victoria-logs-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-logs-$(GOOS)-$(GOARCH)-prod \
			| sed s/-$(GOOS)-$(GOARCH)-prod/-prod/ > victoria-logs-$(GOOS)-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf victoria-logs-$(GOOS)-$(GOARCH)-prod

release-victoria-logs-windows-goarch: victoria-logs-windows-$(GOARCH)-prod
	cd bin && \
		zip victoria-logs-windows-$(GOARCH)-$(PKG_TAG).zip \
			victoria-logs-windows-$(GOARCH)-prod.exe \
		&& sha256sum victoria-logs-windows-$(GOARCH)-$(PKG_TAG).zip \
			victoria-logs-windows-$(GOARCH)-prod.exe \
			> victoria-logs-windows-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf \
		victoria-logs-windows-$(GOARCH)-prod.exe

release-vlogscli:
	$(MAKE_PARALLEL) release-vlogscli-linux-386 \
		release-vlogscli-linux-amd64 \
		release-vlogscli-linux-arm \
		release-vlogscli-linux-arm64 \
		release-vlogscli-darwin-amd64 \
		release-vlogscli-darwin-arm64 \
		release-vlogscli-freebsd-amd64 \
		release-vlogscli-openbsd-amd64 \
		release-vlogscli-windows-amd64

release-vlogscli-linux-386:
	GOOS=linux GOARCH=386 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-linux-amd64:
	GOOS=linux GOARCH=amd64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-linux-arm:
	GOOS=linux GOARCH=arm $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-linux-arm64:
	GOOS=linux GOARCH=arm64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-darwin-amd64:
	GOOS=darwin GOARCH=amd64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-darwin-arm64:
	GOOS=darwin GOARCH=arm64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-freebsd-amd64:
	GOOS=freebsd GOARCH=amd64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-openbsd-amd64:
	GOOS=openbsd GOARCH=amd64 $(MAKE) release-vlogscli-goos-goarch

release-vlogscli-windows-amd64:
	GOARCH=amd64 $(MAKE) release-vlogscli-windows-goarch

release-vlogscli-goos-goarch: vlogscli-$(GOOS)-$(GOARCH)-prod
	cd bin && \
		tar $(TAR_OWNERSHIP) --transform="flags=r;s|-$(GOOS)-$(GOARCH)||" -czf vlogscli-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			vlogscli-$(GOOS)-$(GOARCH)-prod \
		&& sha256sum vlogscli-$(GOOS)-$(GOARCH)-$(PKG_TAG).tar.gz \
			vlogscli-$(GOOS)-$(GOARCH)-prod \
			| sed s/-$(GOOS)-$(GOARCH)-prod/-prod/ > vlogscli-$(GOOS)-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf vlogscli-$(GOOS)-$(GOARCH)-prod

release-vlogscli-windows-goarch: vlogscli-windows-$(GOARCH)-prod
	cd bin && \
		zip vlogscli-windows-$(GOARCH)-$(PKG_TAG).zip \
			vlogscli-windows-$(GOARCH)-prod.exe \
		&& sha256sum vlogscli-windows-$(GOARCH)-$(PKG_TAG).zip \
			vlogscli-windows-$(GOARCH)-prod.exe \
			> vlogscli-windows-$(GOARCH)-$(PKG_TAG)_checksums.txt
	cd bin && rm -rf \
		vlogscli-windows-$(GOARCH)-prod.exe

release-vmutils: \
	release-vmutils-linux-386 \
	release-vmutils-linux-amd64 \
	release-vmutils-linux-arm64 \
	release-vmutils-linux-arm \
	release-vmutils-darwin-amd64 \
	release-vmutils-darwin-arm64 \
	release-vmutils-freebsd-amd64 \
	release-vmutils-openbsd-amd64 \
	release-vmutils-windows-amd64

release-vmutils-linux-386:

=== cspell/Makefile ===
# These commands must be run from the VictoriaMetrics repository root.

# Builds cspell image.
cspell-install:
	@docker build cspell -t cspell

# Checks for spelling errors.
cspell-check: CMD="--no-progress -r /vm"
cspell-check: cspell-install cspell-run

# Runs spelling error check.
# A user facing alias to cspell-check command.
spellcheck: cspell-check

# Runs cspell container commands.
cspell-run:
	@-docker run \
		--mount type=bind,src="$(PWD)",dst=/vm \
		--rm \
		cspell -c cspell/cspell.json "$(CMD)"

cspell-update-deps: cspell-install
	@-docker run \
		--mount type=bind,src="$(PWD)",dst=/vm \
		--entrypoint=/bin/sh \
		--workdir=/vm/cspell \
		--rm \
		cspell -c "yarn install && yarn upgrade && rm -rf ./node_modules"

=== dashboards/Makefile ===
dashboard-copy:
	echo "" > dashboards/vm/${SRC}
	cat dashboards/${SRC} >> dashboards/vm/${SRC}
	sed -i='.tmp' 's/prometheus/victoriametrics-metrics-datasource/g' dashboards/vm/${SRC}
	sed -i='.tmp' 's/Prometheus/VictoriaMetrics/g' dashboards/vm/${SRC}
	sed -i='.tmp' 's/${D_UID}/${D_UID}_vm/g' dashboards/vm/${SRC}
	sed -i='.tmp' 's/"title": "${TITLE}"/"title": "${TITLE} (VM)"/g' dashboards/vm/${SRC}
	rm -rf dashboards/vm/*.tmp

# Copies listed dashboards to vm/* but changes the datasource type from Prometheus to VictoriaMetrics.
# The command should be called before commiting changes to dashboards/* files.
dashboards-sync:
	SRC=victoriametrics.json D_UID=wNf0q_kZk TITLE="VictoriaMetrics - single-node" $(MAKE) dashboard-copy
	SRC=victoriametrics-cluster.json D_UID=oS7Bi_0Wz TITLE="VictoriaMetrics - cluster" $(MAKE) dashboard-copy
	SRC=vmagent.json D_UID=G7Z9GzMGz TITLE="VictoriaMetrics - vmagent" $(MAKE) dashboard-copy
	SRC=vmalert.json D_UID=LzldHAVnz TITLE="VictoriaMetrics - vmalert" $(MAKE) dashboard-copy
	SRC=vmauth.json D_UID=nbuo5Mr4k TITLE="VictoriaMetrics - vmauth" $(MAKE) dashboard-copy
	SRC=operator.json D_UID=1H179hunk TITLE="VictoriaMetrics - operator" $(MAKE) dashboard-copy
	SRC=backupmanager.json D_UID=gF-lxRdVz TITLE="VictoriaMetrics - backupmanager" $(MAKE) dashboard-copy
	SRC=clusterbytenant.json D_UID=IZFqd3lMz TITLE="VictoriaMetrics Cluster Per Tenant Statistic" $(MAKE) dashboard-copy
	SRC=victorialogs.json D_UID=OqPIZTX4z TITLE="VictoriaLogs" $(MAKE) dashboard-copy

=== app/victoria-metrics/Makefile ===
# All these commands must run from repository root.

victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) app-local

victoria-metrics-race:
	APP_NAME=victoria-metrics RACE=-race $(MAKE) app-local

victoria-metrics-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker

victoria-metrics-pure-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-pure

victoria-metrics-linux-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-linux-amd64

victoria-metrics-linux-arm-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-linux-arm

victoria-metrics-linux-arm64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-linux-arm64

victoria-metrics-linux-ppc64le-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-linux-ppc64le

victoria-metrics-linux-386-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-linux-386

victoria-metrics-darwin-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-darwin-amd64

victoria-metrics-darwin-arm64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-darwin-arm64

victoria-metrics-freebsd-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-freebsd-amd64

victoria-metrics-openbsd-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-openbsd-amd64

victoria-metrics-windows-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-windows-amd64

package-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker

package-victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-pure

package-victoria-metrics-amd64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-amd64

package-victoria-metrics-arm:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm

package-victoria-metrics-arm64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm64

package-victoria-metrics-ppc64le:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-ppc64le

package-victoria-metrics-386:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-386

publish-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) publish-via-docker

run-victoria-metrics:
	mkdir -p victoria-metrics-data
	DOCKER_OPTS='-v $(shell pwd)/victoria-metrics-data:/victoria-metrics-data' \
	APP_NAME=victoria-metrics \
	ARGS='-graphiteListenAddr=:2003 -opentsdbListenAddr=:4242 -retentionPeriod=12 -search.maxUniqueTimeseries=1000000 -search.maxQueryDuration=10m' \
	$(MAKE) run-via-docker

victoria-metrics-linux-amd64:
	APP_NAME=victoria-metrics CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

victoria-metrics-linux-arm:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

victoria-metrics-linux-arm64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

victoria-metrics-linux-ppc64le:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

victoria-metrics-linux-s390x:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

victoria-metrics-linux-loong64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

victoria-metrics-linux-386:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

victoria-metrics-darwin-amd64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

victoria-metrics-darwin-arm64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

victoria-metrics-freebsd-amd64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

victoria-metrics-openbsd-amd64:
	APP_NAME=victoria-metrics CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

victoria-metrics-windows-amd64:
	GOARCH=amd64 APP_NAME=victoria-metrics $(MAKE) app-local-windows-goarch

victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) app-local-pure

### Packaging as DEB - amd64
victoria-metrics-package-deb-amd64: victoria-metrics-linux-amd64-prod
	./package/package_deb.sh amd64

### Packaging as DEB - arm64
victoria-metrics-package-deb-arm: victoria-metrics-linux-arm-prod
	./package/package_deb.sh arm

### Packaging as DEB - arm64
victoria-metrics-package-deb-arm64: victoria-metrics-linux-arm64-prod
	./package/package_deb.sh arm64

### Packaging as DEB - all
victoria-metrics-package-deb: \
        victoria-metrics-package-deb-amd64 \
        victoria-metrics-package-deb-arm \
        victoria-metrics-package-deb-arm64

### Packaging as RPM - amd64
victoria-metrics-package-rpm-amd64: victoria-metrics-linux-amd64-prod
	./package/package_rpm.sh amd64

### Packaging as RPM - arm64
victoria-metrics-package-rpm-arm64: victoria-metrics-linux-arm64-prod
	./package/package_rpm.sh arm64

### Packaging as RPM - all
victoria-metrics-package-rpm: \
        victoria-metrics-package-rpm-amd64 \
        victoria-metrics-package-rpm-arm64

### Packaging as both DEB and RPM - all
victoria-metrics-package-deb-rpm: \
        victoria-metrics-package-deb \
        victoria-metrics-package-rpm

=== app/vlogscli/Makefile ===
# All these commands must run from repository root.

vlogscli:
	APP_NAME=vlogscli $(MAKE) app-local

vlogscli-race:
	APP_NAME=vlogscli RACE=-race $(MAKE) app-local

vlogscli-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker

vlogscli-pure-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-pure

vlogscli-linux-amd64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-linux-amd64

vlogscli-linux-arm-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-linux-arm

vlogscli-linux-arm64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-linux-arm64

vlogscli-linux-ppc64le-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-linux-ppc64le

vlogscli-linux-386-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-linux-386

vlogscli-darwin-amd64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-darwin-amd64

vlogscli-darwin-arm64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-darwin-arm64

vlogscli-freebsd-amd64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-freebsd-amd64

vlogscli-openbsd-amd64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-openbsd-amd64

vlogscli-windows-amd64-prod:
	APP_NAME=vlogscli $(MAKE) app-via-docker-windows-amd64

package-vlogscli:
	APP_NAME=vlogscli $(MAKE) package-via-docker

package-vlogscli-pure:
	APP_NAME=vlogscli $(MAKE) package-via-docker-pure

package-vlogscli-amd64:
	APP_NAME=vlogscli $(MAKE) package-via-docker-amd64

package-vlogscli-arm:
	APP_NAME=vlogscli $(MAKE) package-via-docker-arm

package-vlogscli-arm64:
	APP_NAME=vlogscli $(MAKE) package-via-docker-arm64

package-vlogscli-ppc64le:
	APP_NAME=vlogscli $(MAKE) package-via-docker-ppc64le

package-vlogscli-386:
	APP_NAME=vlogscli $(MAKE) package-via-docker-386

publish-vlogscli:
	APP_NAME=vlogscli $(MAKE) publish-via-docker

vlogscli-linux-amd64:
	APP_NAME=vlogscli CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vlogscli-linux-arm:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vlogscli-linux-arm64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vlogscli-linux-ppc64le:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vlogscli-linux-s390x:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vlogscli-linux-loong64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vlogscli-linux-386:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vlogscli-darwin-amd64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vlogscli-darwin-arm64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vlogscli-freebsd-amd64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vlogscli-openbsd-amd64:
	APP_NAME=vlogscli CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vlogscli-windows-amd64:
	GOARCH=amd64 APP_NAME=vlogscli $(MAKE) app-local-windows-goarch

vlogscli-pure:
	APP_NAME=vlogscli $(MAKE) app-local-pure

run-vlogscli:
	APP_NAME=vlogscli $(MAKE) run-via-docker

=== app/vlogsgenerator/Makefile ===
# All these commands must run from repository root.

vlogsgenerator:
	APP_NAME=vlogsgenerator $(MAKE) app-local

vlogsgenerator-race:
	APP_NAME=vlogsgenerator RACE=-race $(MAKE) app-local

=== app/vmalert-tool/Makefile ===
# All these commands must run from repository root.

vmalert-tool:
	APP_NAME=vmalert-tool $(MAKE) app-local

vmalert-tool-race:
	APP_NAME=vmalert-tool RACE=-race $(MAKE) app-local

vmalert-tool-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker

vmalert-tool-pure-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-pure

vmalert-tool-linux-amd64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-linux-amd64

vmalert-tool-linux-arm-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-linux-arm

vmalert-tool-linux-arm64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-linux-arm64

vmalert-tool-linux-ppc64le-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-linux-ppc64le

vmalert-tool-linux-386-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-linux-386

vmalert-tool-darwin-amd64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-darwin-amd64

vmalert-tool-darwin-arm64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-darwin-arm64

vmalert-tool-freebsd-amd64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-freebsd-amd64

vmalert-tool-openbsd-amd64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-openbsd-amd64

vmalert-tool-windows-amd64-prod:
	APP_NAME=vmalert-tool $(MAKE) app-via-docker-windows-amd64

package-vmalert-tool:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker

package-vmalert-tool-pure:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-pure

package-vmalert-tool-amd64:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-amd64

package-vmalert-tool-arm:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-arm

package-vmalert-tool-arm64:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-arm64

package-vmalert-tool-ppc64le:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-ppc64le

package-vmalert-tool-386:
	APP_NAME=vmalert-tool $(MAKE) package-via-docker-386

publish-vmalert-tool:
	APP_NAME=vmalert-tool $(MAKE) publish-via-docker

vmalert-tool-linux-amd64:
	APP_NAME=vmalert-tool CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-tool-linux-arm:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmalert-tool-linux-arm64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmalert-tool-linux-ppc64le:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmalert-tool-linux-s390x:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmalert-tool-linux-loong64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmalert-tool-linux-386:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmalert-tool-darwin-amd64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-tool-darwin-arm64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmalert-tool-freebsd-amd64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-tool-openbsd-amd64:
	APP_NAME=vmalert-tool CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-tool-windows-amd64:
	GOARCH=amd64 APP_NAME=vmalert-tool $(MAKE) app-local-windows-goarch

vmalert-tool-pure:
	APP_NAME=vmalert-tool $(MAKE) app-local-pure

=== app/vmalert/Makefile ===
# All these commands must run from repository root.

vmalert:
	APP_NAME=vmalert $(MAKE) app-local

vmalert-race:
	APP_NAME=vmalert RACE=-race $(MAKE) app-local

vmalert-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker

vmalert-pure-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-pure

vmalert-linux-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-linux-amd64

vmalert-linux-arm-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-linux-arm

vmalert-linux-arm64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-linux-arm64

vmalert-linux-ppc64le-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-linux-ppc64le

vmalert-linux-386-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-linux-386

vmalert-darwin-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-darwin-amd64

vmalert-darwin-arm64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-darwin-arm64

vmalert-freebsd-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-freebsd-amd64

vmalert-openbsd-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-openbsd-amd64

vmalert-windows-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-windows-amd64

package-vmalert:
	APP_NAME=vmalert $(MAKE) package-via-docker

package-vmalert-pure:
	APP_NAME=vmalert $(MAKE) package-via-docker-pure

package-vmalert-amd64:
	APP_NAME=vmalert $(MAKE) package-via-docker-amd64

package-vmalert-arm:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm

package-vmalert-arm64:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm64

package-vmalert-ppc64le:
	APP_NAME=vmalert $(MAKE) package-via-docker-ppc64le

package-vmalert-386:
	APP_NAME=vmalert $(MAKE) package-via-docker-386

publish-vmalert:
	APP_NAME=vmalert $(MAKE) publish-via-docker

test-vmalert:
	go test -v -race -cover ./app/vmalert -loggerLevel=ERROR
	go test -v -race -cover ./app/vmalert/rule
	go test -v -race -cover ./app/vmalert/templates
	go test -v -race -cover ./app/vmalert/datasource
	go test -v -race -cover ./app/vmalert/notifier
	go test -v -race -cover ./app/vmalert/config
	go test -v -race -cover ./app/vmalert/remotewrite
	go test -v -race -cover ./app/vmalert/utils

run-vmalert: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules/rules2-good.rules \
		-datasource.url=http://localhost:8428 \
		-notifier.url=http://localhost:9093 \
		-notifier.url=http://127.0.0.1:9093 \
		-remoteWrite.url=http://localhost:8428 \
		-remoteRead.url=http://localhost:8428 \
		-external.label=cluster=east-1 \
		-external.label=replica=a \
		-evaluationInterval=3s \
		-configCheckInterval=10s

run-vmalert-sd: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules2-good.rules \
		-datasource.url=http://localhost:8428 \
		-remoteWrite.url=http://localhost:8428 \
		-notifier.config=app/vmalert/notifier/testdata/mixed.good.yaml \
		-configCheckInterval=10s

replay-vmalert: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules/rules-replay-good.rules \
		-datasource.url=http://localhost:8428 \
		-remoteWrite.url=http://localhost:8428 \
		-external.label=cluster=east-1 \
		-external.label=replica=a \
		-replay.timeFrom=2024-06-01T00:00:00Z

vmalert-linux-amd64:
	APP_NAME=vmalert CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-linux-arm:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmalert-linux-arm64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmalert-linux-ppc64le:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmalert-linux-s390x:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmalert-linux-loong64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmalert-linux-386:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmalert-darwin-amd64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-darwin-arm64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmalert-freebsd-amd64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-openbsd-amd64:
	APP_NAME=vmalert CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmalert-windows-amd64:
	GOARCH=amd64 APP_NAME=vmalert $(MAKE) app-local-windows-goarch

vmalert-pure:
	APP_NAME=vmalert $(MAKE) app-local-pure

=== app/vmauth/Makefile ===
# All these commands must run from repository root.

vmauth:
	APP_NAME=vmauth $(MAKE) app-local

vmauth-race:
	APP_NAME=vmauth RACE=-race $(MAKE) app-local

vmauth-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker

vmauth-pure-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-pure

vmauth-linux-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-linux-amd64

vmauth-linux-arm-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-linux-arm

vmauth-linux-arm64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-linux-arm64

vmauth-linux-ppc64le-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-linux-ppc64le

vmauth-linux-386-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-linux-386

vmauth-darwin-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-darwin-amd64

vmauth-darwin-arm64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-darwin-arm64

vmauth-freebsd-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-freebsd-amd64

vmauth-openbsd-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-openbsd-amd64

vmauth-windows-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-windows-amd64

package-vmauth:
	APP_NAME=vmauth $(MAKE) package-via-docker

package-vmauth-pure:
	APP_NAME=vmauth $(MAKE) package-via-docker-pure

package-vmauth-amd64:
	APP_NAME=vmauth $(MAKE) package-via-docker-amd64

package-vmauth-arm:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm

package-vmauth-arm64:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm64

package-vmauth-ppc64le:
	APP_NAME=vmauth $(MAKE) package-via-docker-ppc64le

package-vmauth-386:
	APP_NAME=vmauth $(MAKE) package-via-docker-386

publish-vmauth:
	APP_NAME=vmauth $(MAKE) publish-via-docker

run-vmauth:
	APP_NAME=vmauth \
	DOCKER_OPTS='-v $(shell pwd)/app/vmauth/:/app/vmauth' \
	ARGS='-auth.config=app/vmauth/example_config.yml' \
	$(MAKE) run-via-docker

vmauth-linux-amd64:
	APP_NAME=vmauth CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmauth-linux-arm:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmauth-linux-arm64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmauth-linux-ppc64le:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmauth-linux-s390x:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmauth-linux-loong64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmauth-linux-386:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmauth-darwin-amd64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmauth-darwin-arm64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmauth-freebsd-amd64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmauth-openbsd-amd64:
	APP_NAME=vmauth CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmauth-windows-amd64:
	GOARCH=amd64 APP_NAME=vmauth $(MAKE) app-local-windows-goarch

vmauth-pure:
	APP_NAME=vmauth $(MAKE) app-local-pure

=== app/vmbackup/Makefile ===
# All these commands must run from repository root.

vmbackup:
	APP_NAME=vmbackup $(MAKE) app-local

vmbackup-race:
	APP_NAME=vmbackup RACE=-race $(MAKE) app-local

vmbackup-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker

vmbackup-pure-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-pure

vmbackup-linux-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-linux-amd64

vmbackup-linux-arm-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-linux-arm

vmbackup-linux-arm64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-linux-arm64

vmbackup-linux-ppc64le-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-linux-ppc64le

vmbackup-linux-386-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-linux-386

vmbackup-darwin-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-darwin-amd64

vmbackup-darwin-arm64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-darwin-arm64

vmbackup-freebsd-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-freebsd-amd64

vmbackup-openbsd-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-openbsd-amd64

vmbackup-windows-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-windows-amd64

package-vmbackup:
	APP_NAME=vmbackup $(MAKE) package-via-docker

package-vmbackup-pure:
	APP_NAME=vmbackup $(MAKE) package-via-docker-pure

package-vmbackup-amd64:
	APP_NAME=vmbackup $(MAKE) package-via-docker-amd64

package-vmbackup-arm:
	APP_NAME=vmbackup $(MAKE) package-via-docker-arm

package-vmbackup-arm64:
	APP_NAME=vmbackup $(MAKE) package-via-docker-arm64

package-vmbackup-ppc64le:
	APP_NAME=vmbackup $(MAKE) package-via-docker-ppc64le

package-vmbackup-386:
	APP_NAME=vmbackup $(MAKE) package-via-docker-386

publish-vmbackup:
	APP_NAME=vmbackup $(MAKE) publish-via-docker

vmbackup-linux-amd64:
	APP_NAME=vmbackup CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmbackup-linux-arm:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmbackup-linux-arm64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmbackup-linux-ppc64le:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmbackup-linux-s390x:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmbackup-linux-loong64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmbackup-linux-386:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmbackup-darwin-amd64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmbackup-darwin-arm64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmbackup-freebsd-amd64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmbackup-openbsd-amd64:
	APP_NAME=vmbackup CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmbackup-windows-amd64:
	GOARCH=amd64 APP_NAME=vmbackup $(MAKE) app-local-windows-goarch

vmbackup-pure:
	APP_NAME=vmbackup $(MAKE) app-local-pure

=== app/vmctl/Makefile ===
# All these commands must run from repository root.

vmctl:
	APP_NAME=vmctl $(MAKE) app-local

vmctl-race:
	APP_NAME=vmctl RACE=-race $(MAKE) app-local

vmctl-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker

vmctl-pure-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-pure

vmctl-linux-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-linux-amd64

vmctl-linux-arm-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-linux-arm

vmctl-linux-arm64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-linux-arm64

vmctl-linux-ppc64le-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-linux-ppc64le

vmctl-linux-386-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-linux-386

vmctl-darwin-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-darwin-amd64

vmctl-darwin-arm64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-darwin-arm64

vmctl-freebsd-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-freebsd-amd64

vmctl-openbsd-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-openbsd-amd64

vmctl-windows-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-windows-amd64

package-vmctl:
	APP_NAME=vmctl $(MAKE) package-via-docker

package-vmctl-pure:
	APP_NAME=vmctl $(MAKE) package-via-docker-pure

package-vmctl-amd64:
	APP_NAME=vmctl $(MAKE) package-via-docker-amd64

package-vmctl-arm:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm

package-vmctl-arm64:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm64

package-vmctl-ppc64le:
	APP_NAME=vmctl $(MAKE) package-via-docker-ppc64le

package-vmctl-386:
	APP_NAME=vmctl $(MAKE) package-via-docker-386

publish-vmctl:
	APP_NAME=vmctl $(MAKE) publish-via-docker

vmctl-linux-amd64:
	APP_NAME=vmctl CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmctl-linux-arm:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmctl-linux-arm64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmctl-linux-ppc64le:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmctl-linux-s390x:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmctl-linux-loong64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmctl-linux-386:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmctl-darwin-amd64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmctl-darwin-arm64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmctl-freebsd-amd64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmctl-openbsd-amd64:
	APP_NAME=vmctl CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmctl-windows-amd64:
	GOARCH=amd64 APP_NAME=vmctl $(MAKE) app-local-windows-goarch

vmctl-pure:
	APP_NAME=vmctl $(MAKE) app-local-pure

=== app/vmrestore/Makefile ===
# All these commands must run from repository root.

vmrestore:
	APP_NAME=vmrestore $(MAKE) app-local

vmrestore-race:
	APP_NAME=vmrestore RACE=-race $(MAKE) app-local

vmrestore-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker

vmrestore-pure-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-pure

vmrestore-linux-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-linux-amd64

vmrestore-linux-arm-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-linux-arm

vmrestore-linux-arm64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-linux-arm64

vmrestore-linux-ppc64le-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-linux-ppc64le

vmrestore-linux-386-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-linux-386

vmrestore-darwin-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-darwin-amd64

vmrestore-darwin-arm64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-darwin-arm64

vmrestore-freebsd-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-freebsd-amd64

vmrestore-openbsd-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-openbsd-amd64

vmrestore-windows-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-windows-amd64

package-vmrestore:
	APP_NAME=vmrestore $(MAKE) package-via-docker

package-vmrestore-pure:
	APP_NAME=vmrestore $(MAKE) package-via-docker-pure

package-vmrestore-amd64:
	APP_NAME=vmrestore $(MAKE) package-via-docker-amd64

package-vmrestore-arm:
	APP_NAME=vmrestore $(MAKE) package-via-docker-arm

package-vmrestore-arm64:
	APP_NAME=vmrestore $(MAKE) package-via-docker-arm64

package-vmrestore-ppc64le:
	APP_NAME=vmrestore $(MAKE) package-via-docker-ppc64le

package-vmrestore-386:
	APP_NAME=vmrestore $(MAKE) package-via-docker-386

publish-vmrestore:
	APP_NAME=vmrestore $(MAKE) publish-via-docker

vmrestore-linux-amd64:
	APP_NAME=vmrestore CGO_ENABLED=1 GOOS=linux GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmrestore-linux-arm:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=arm $(MAKE) app-local-goos-goarch

vmrestore-linux-arm64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmrestore-linux-ppc64le:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le $(MAKE) app-local-goos-goarch

vmrestore-linux-s390x:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=s390x $(MAKE) app-local-goos-goarch

vmrestore-linux-loong64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=loong64 $(MAKE) app-local-goos-goarch

vmrestore-linux-386:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=linux GOARCH=386 $(MAKE) app-local-goos-goarch

vmrestore-darwin-amd64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmrestore-darwin-arm64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-local-goos-goarch

vmrestore-freebsd-amd64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=freebsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmrestore-openbsd-amd64:
	APP_NAME=vmrestore CGO_ENABLED=0 GOOS=openbsd GOARCH=amd64 $(MAKE) app-local-goos-goarch

vmrestore-windows-amd64:
	GOARCH=amd64 APP_NAME=vmrestore $(MAKE) app-local-windows-goarch

vmrestore-pure:
	APP_NAME=vmrestore $(MAKE) app-local-pure

=== debian/changelog ===
victoriametrics (1.112.0+ds1-4) unstable; urgency=medium

  * Team upload
  * Skip additional memory-intensive test on armel, which causes build
    failures on Debian build daemons

 -- Daniel Swarbrick <dswarbrick@debian.org>  Mon, 18 Aug 2025 15:16:39 +0000

victoriametrics (1.112.0+ds1-3) unstable; urgency=medium

  * Team upload
  * Add new Support-prometheus-common-v0.62.0.patch

 -- Daniel Swarbrick <dswarbrick@debian.org>  Mon, 18 Aug 2025 12:40:13 +0000

victoriametrics (1.112.0+ds1-2) unstable; urgency=medium

  * Fix FTBFS on systems with a single CPU. (Closes: #1107327)

 -- Guillem Jover <gjover@sipwise.com>  Wed, 11 Jun 2025 20:32:22 +0200

victoriametrics (1.112.0+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Skip memory test on arm.
  * Update vmui Files-Excluded.
  * Remove patch skipping failing test, fixed upstream.

 -- Guillem Jover <gjover@sipwise.com>  Wed, 26 Feb 2025 20:33:24 +0100

=== debian/control ===
Source: victoriametrics
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Guillem Jover <gjover@sipwise.com>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-bboreham-go-loser-dev,
 golang-github-bmatcuk-doublestar-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1~),
 golang-github-cheggaaa-pb.v3-dev (>= 3.1.0~),
 golang-github-gogo-protobuf-dev,
 golang-github-golang-snappy-dev,
 golang-github-google-go-cmp-dev,
 golang-github-google-s2a-go-dev,
 golang-github-googleapis-enterprise-certificate-proxy-dev,
 golang-github-googleapis-gax-go-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5~),
 golang-github-mattn-go-isatty-dev,
 golang-github-urfave-cli-v2-dev,
 golang-github-valyala-fastjson-dev (>= 1.6.1~),
 golang-github-valyala-fastrand-dev <!nocheck>,
 golang-github-valyala-fasttemplate-dev,
 golang-github-valyala-gozstd-dev,
 golang-github-valyala-histogram-dev,
 golang-github-valyala-quicktemplate-dev (>= 1.8.0~),
 golang-github-victoriametrics-easyproto-dev,
 golang-github-victoriametrics-fastcache-dev (>= 1.8.0~),
 golang-github-victoriametrics-metrics-dev (>= 1.24.0~),
 golang-github-victoriametrics-metricsql-dev (>= 0.83.0~),
 golang-golang-x-net-dev,
 golang-golang-x-oauth2-google-dev (>= 0.25.0~),
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0~),
 golang-google-cloud-dev (>= 0.49.0~),
 golang-gopkg-yaml.v2-dev,
# Needed by vendored module (github.com/Azure/azure-sdk-for-go)
 golang-github-azuread-microsoft-authentication-library-for-go-dev,
# Needed by vendored module (github.com/prometheus/prometheus/)
 golang-github-dennwc-varint-dev,
 golang-github-go-kit-log-dev,
 golang-github-grafana-regexp-dev,
 golang-github-oklog-ulid-dev,
 golang-github-pkg-errors-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-common-dev (>= 0.62.0~),
 golang-github-prometheus-sigv4-dev,
 golang-go.uber-atomic-dev,
 golang-go.uber-multierr-dev,
 golang-k8s-client-go-dev,
 golang-opentelemetry-contrib-dev,
 golang-opentelemetry-otel-dev,
 golang-uber-goleak-dev,
Standards-Version: 4.7.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/victoriametrics
Vcs-Git: https://salsa.debian.org/go-team/packages/victoriametrics.git
Homepage: https://github.com/VictoriaMetrics/VictoriaMetrics
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/VictoriaMetrics/VictoriaMetrics

Package: victoria-metrics
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Static-Built-Using: ${misc:Static-Built-Using}
Description: fast, cost-effective and scalable time series database
 VictoriaMetrics is a fast, cost-effective and scalable time-series database.
 It can be used as long-term remote storage for Prometheus.
 .
 Prominent features:
  * Supports Prometheus querying API, so it can be used as Prometheus
    drop-in replacement in Grafana. VictoriaMetrics implements MetricsQL
    query language, which is inspired by PromQL.
  * Supports global query view. Multiple Prometheus instances may write
    data into VictoriaMetrics. Later this data may be used in a single query.
  * High performance and good scalability for both inserts and selects.
    Outperforms InfluxDB and TimescaleDB by up to 20x.
  * Uses 10x less RAM than InfluxDB when working with millions of unique time
    series (aka high cardinality).
  * Optimized for time series with high churn rate. Think about
    prometheus-operator metrics from frequent deployments in Kubernetes.
  * High data compression, so up to 70x more data points may be crammed into
    limited storage comparing to TimescaleDB.
  * Optimized for storage with high-latency IO and low IOPS (HDD and network
    storage in AWS, Google Cloud, Microsoft Azure, etc).
  * A single-node VictoriaMetrics may substitute moderately sized clusters
    built with competing solutions such as Thanos, M3DB, Cortex, InfluxDB or
    TimescaleDB.
  * Easy operation:
    - VictoriaMetrics consists of a single small executable without external
      dependencies.
    - All the configuration is done via explicit command-line flags with
      reasonable defaults.
    - All the data is stored in a single directory pointed by
      -storageDataPath flag.
    - Easy and fast backups from instant snapshots to S3 or GCS with
      vmbackup / vmrestore.
    - Data migration between VictoriaMetrics, Prometheus and InfluxDB with
      vmctl.
  * Storage is protectedfrom corruption on unclean shutdown (i.e. OOM,
    hardware reset or kill -9) thanks to the storage architecture.
  * Supports metrics' scraping, ingestion and backfilling (#backfilling)
    via the following protocols:
    - Metrics from Prometheus exporters such as node_exporter.
    - Prometheus remote write API
    - InfluxDB line protocol
    - Graphite plaintext protocol with tags if -graphiteListenAddr is set.
    - OpenTSDB put message if -opentsdbListenAddr is set.
    - HTTP OpenTSDB /api/put requests if -opentsdbHTTPListenAddr is set.
    - /api/v1/import.
  * Ideally works with big amounts of time series data from Kubernetes, IoT
    sensors, connected cars, industrial telemetry, financial data and
    various Enterprise workloads.
  * Has open source cluster version.

Package: golang-github-victoriametrics-victoriametrics-dev
Section: golang
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-aws-aws-sdk-go-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1~),
 golang-github-golang-snappy-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5~),
 golang-github-valyala-fasttemplate-dev,
 golang-golang-x-oauth2-google-dev (>= 0.25.0~),
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0~),
 golang-google-cloud-dev (>= 0.49.0~),
 golang-gopkg-yaml.v2-dev,
 ${misc:Depends},
Description: fast, cost-effective and scalable time series database (library)
 This package provides the library code for VictoriaMetrics.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DH_GOLANG_EXCLUDES := \
	apptest/ \
	# EOL

export DH_GOLANG_INSTALL_EXTRA := \
	app/vmalert/templates/templates/ \
	app/vmselect/graphite/functions.json \
	lib/httpserver/favicon.ico \
	# EOL

%:
	dh $@ --builddirectory=_build --buildsystem=golang

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386 armel))
override_dh_auto_test:
	# Ignore errors due to floating point comparisons w/o epsilon.
	-dh_auto_test
endif
